'***************************************
' PowerBasic FORUM for Masses
' HTML Parser
'***************************************
'#COMPILE DLL

#COMPILE DLL "forumPar.dll"
#DIM ALL
'#INCLUDE "WIN32API.INC"
'#INCLUDE "debugdlg.inc"
DECLARE FUNCTION fpCountTables   (STRING) AS LONG
DECLARE FUNCTION fpRemoveTags    (STRING) AS STRING
DECLARE FUNCTION RemoveAndReplaceTags (STRING,STRING,STRING,STRING) AS LONG
DECLARE FUNCTION MemLineInput    (STRING,OPT BYVAL LONG) AS STRING
DECLARE SUB tstShowTable(BYVAL LONG)
DECLARE SUB outt (STRING)
'  
DECLARE FUNCTION replace_Link( str AS STRING )AS STRING
GLOBAL gHTTP AS STRING


TYPE TTableInfo
     Rows     AS LONG
     Cols     AS LONG
     LLines    AS LONG
     StartPos AS LONG
     EndPos   AS LONG
     Length   AS LONG
END TYPE
GLOBAL HT()         AS TTableInfo
GLOBAL HTContent()  AS STRING
GLOBAL MemEOS       AS LONG

%T_Tables  = 0
%T_Rows    = 1
%T_Cols    = 2
%T_Lines   = 3
$Table_Tag = "</TABLE>"

%DLL_PROCESS_DETACH = 0
%DLL_PROCESS_ATTACH = 1
%DLL_THREAD_ATTACH  = 2
%DLL_THREAD_DETACH  = 3

FUNCTION LIBMAIN (BYVAL hInstance AS LONG,BYVAL Reason AS LONG,BYVAL Reserved AS LONG) EXPORT AS LONG
    SELECT CASE Reason
    CASE %DLL_PROCESS_ATTACH
         LIBMAIN = 1
         EXIT FUNCTION
    CASE %DLL_PROCESS_DETACH
         ERASE HT() , HTContent() ' deallocate memory
         EXIT FUNCTION
    CASE %DLL_THREAD_ATTACH
         EXIT FUNCTION
    CASE %DLL_THREAD_DETACH
         ERASE HT() , HTContent() ' deallocate memory
         EXIT FUNCTION
  END SELECT
END FUNCTION

FUNCTION fpReadCell ALIAS "fpReadCell" (BYVAL Tbl_Num AS LONG,BYVAL at_row AS LONG,BYVAL at_col AS LONG) EXPORT AS STRING

    LOCAL j_row    AS LONG , j_col AS LONG
    LOCAL FoundRow AS LONG
    LOCAL FoundCol AS LONG
    LOCAL j        AS LONG
    LOCAL tmp_st   AS STRING , rs AS STRING , hm AS STRING

    IF Tbl_Num > UBOUND(HT) AND Tbl_Num < LBOUND(HT) THEN Tbl_Num = LBOUND(HT)
    IF at_row < 1 THEN at_row = 1
    IF at_col < 1 THEN at_col = 1
    IF at_row > HT(Tbl_Num).Rows THEN at_row = HT(Tbl_Num).Rows
    IF at_col > HT(Tbl_Num).Cols THEN at_col = HT(Tbl_Num).Cols

    FoundRow = 0
    FoundCol = 0
    tmp_st   = ""
    j_col    = 0
    j_row    = 0

    rs = MemLineInput ( "" , 1 ) ' initialize MemLineInput

    FOR j  = 1 TO HT(Tbl_Num).LLines
        rs = MemLineInput( HTContent(Tbl_Num) )
        SELECT CASE rs
            CASE "<TR>"
              IF FoundRow=0 THEN INCR j_row
            CASE "<TD>"
              IF ( FoundCol=0  AND FoundRow=-1 ) THEN INCR j_col
            CASE "</TD>"
              IF ( FoundCol=-1 AND FoundRow=-1 ) THEN EXIT FOR
            CASE ELSE
              IF ( FoundCol AND FoundRow ) THEN tmp_st = tmp_st & rs & $CRLF
        END SELECT
        IF j_row = at_row AND FoundRow = 0  AND FoundCol = 0 THEN FoundRow = -1 : ITERATE
        IF j_col = at_col AND FoundRow = -1 AND FoundCol = 0 THEN FoundCol = -1 : ITERATE
    NEXT j
    FUNCTION = tmp_st
END FUNCTION

FUNCTION fpLoadAndParse  ALIAS "fpLoadAndParse" (file_to_parse AS ASCIIZ) EXPORT AS LONG

     LOCAL cur_row AS LONG
     LOCAL st_tmp  AS STRING , res AS STRING , rd_html AS STRING
     LOCAL c1      AS LONG   , c2  AS LONG
     LOCAL tbl_Cnt AS LONG   , i   AS LONG
     LOCAL ff      AS INTEGER

     '------------------------------------------------------------
     '     
     gHTTP = ""
     '------------------------------------------------------------


     '------------------------------------------------------------
     ' Open HTM file and copy content into string
     '------------------------------------------------------------
     res     = ""
     rd_html = ""
     ff      = FREEFILE
     OPEN file_to_parse FOR INPUT AS ff
      DO WHILE NOT EOF(ff)
       LINE INPUT #ff, st_tmp : res = res & st_tmp
        LOOP
         CLOSE ff

     '+++
     REPLACE "'MESSAGE" WITH "'Message" IN res
     '---

     '------------------------------------------------------------
     ' capitalize all tags to remove them easy later
     '-----------------------------------------------------------
     c1 = 0
     FOR i = 1 TO LEN(res)
         IF MID$( res , i , 1 ) = "<" THEN c1 = -1 : ITERATE
         IF MID$( res , i , 1 ) = ">" AND  c1 = -1 THEN c1 = 0 : ITERATE
         IF c1 = -1 THEN MID$( res , i , 1 ) = UCASE$(MID$( res , i , 1 ))
     NEXT
     '-----------------------------------------------------------
     ' Count Tables
     '-----------------------------------------------------------
     tbl_Cnt  = fpCountTables ( res )
     IF tbl_Cnt = 0 THEN
'        MSGBOX "The file " & UCASE$(file_to_parse) & " have no tables ",,"FParser: Error"
        'DPRINT "The file " & UCASE$(file_to_parse) & " have no tables ,FParser: Error"
        FUNCTION = 0
        EXIT FUNCTION
     END IF
     '----------------------------------------------------------------------
     ' preformat all tables, remove tags and calculate rows and cols.
     '----------------------------------------------------------------------
     FOR i = 1 TO tbl_Cnt
         HTContent(i) = fpRemoveTags ( HTContent(i) )
         HT(i).LLines  = TALLY ( HTContent(i) , $CRLF  )
         HT(i).Rows   = TALLY ( HTContent(i) , "<TR>" )
         HT(i).Cols   = TALLY ( HTContent(i) , "<TD>" ) / HT(i).Rows
     NEXT i
     FUNCTION = tbl_Cnt
END FUNCTION

'************************************************************************
' Search for tables in html and prepare necessary information:
' Starting and Ending position inside html and theyir length
'------------------------------------------------------------------------
FUNCTION fpCountTables (stAnalyze AS STRING) AS LONG
    LOCAL c1 AS LONG,c2 AS LONG, ipos AS LONG , tbl_Cnt AS LONG , L AS LONG
    LOCAL StartFired AS LONG,EndFired AS LONG
    ERASE HT() , HTContent()
    tbl_Cnt  = 0 : ipos = 1
    StartFired = 0 : EndFired = 0
    L = LEN( stAnalyze )
    DO
      IF MID$( stAnalyze , ipos , 6 ) = "<TABLE"   THEN c1 = ipos : StartFired = -1
      IF MID$( stAnalyze , ipos , 8 ) = $Table_Tag THEN c2 = ipos : EndFired   = -1
      IF (StartFired AND EndFired) THEN
         INCR tbl_Cnt
         ipos = c2
         REDIM PRESERVE HT(1 TO tbl_Cnt) AS TTableInfo
         REDIM PRESERVE HTContent(1 TO tbl_Cnt) AS STRING
         HT(tbl_Cnt).StartPos = c1
         HT(tbl_Cnt).EndPos   = c2
         HT(tbl_Cnt).Length   = c2 - c1 + LEN($Table_Tag)
         HTContent(tbl_Cnt)   = MID$( stAnalyze , c1 , HT(tbl_Cnt).Length )
         StartFired = 0 : EndFired = 0
         ipos = c2
      END IF
      INCR ipos
      IF ipos > L THEN EXIT DO
    LOOP
    FUNCTION = Tbl_Cnt
END FUNCTION

'************************************************************************
' Line Input analog function that works with dynamic strings
' Open text file, read once into one dynamic string and close file.
' Use MemLineInput to read each line of string.
'   The global variable MemEOS (ie. MemEndOfString) is similar to EOF
'   init_posn - initialize starting position to scan $CRLF code in string
'-------------------------------------------------------------------------
FUNCTION MemLineInput (input_st AS STRING, OPT BYVAL init_posn AS LONG) PRIVATE AS STRING
     STATIC L AS LONG
     LOCAL  C AS LONG
     IF init_posn THEN L = 1 : EXIT FUNCTION
     IF L = 0 THEN L = 1
     memEOS = 0
     C = INSTR(L , input_st , $CRLF)
     IF C THEN
        FUNCTION = MID$( input_st , L , C - L )
        L = C + 2
     END IF
     IF L > = LEN( input_st ) THEN
        memEOS = -1
     END IF
END FUNCTION

'************************************************************************
' Remove and Replace Tag.
' Find in 'mainst' string that start with 'Start_Tag'
' and end with 'End_tag' and replace with 'Replace_with'
' Use this function in loop to replace all tags.
'------------------------------------------------------------------------
FUNCTION RemoveAndReplaceTags(mainst AS STRING,start_tag AS STRING,end_tag AS STRING, replace_with AS STRING) PRIVATE AS LONG
     LOCAL cpos1 AS LONG,cpos2 AS LONG,newst AS STRING
     cpos1 = INSTR( mainst , start_tag )
     IF cpos1 = 0 THEN FUNCTION = 0 : EXIT FUNCTION ' all done or nothing to replace
     cpos2 = INSTR( cpos1 , mainst , end_tag )
     '+++
     IF start_tag = "<A HREF=" AND  end_tag = "</A>" THEN
        replace_with  = replace_Link(MID$(mainst,cpos1,cpos2 - cpos1 ))
     END IF
     '---
     mainst = LEFT$( mainst , cpos1 - 1 ) & _
              replace_with & _
              RIGHT$( mainst , LEN( mainst ) - cpos2 - LEN( end_tag ) + 1 )
     FUNCTION = -1 ' replaced once.
END FUNCTION

FUNCTION fpRemoveTags (stHtml AS STRING) AS STRING
     '--------------------------------------------------------------------------
     ' Remove unnecessary tags
     '--------------------------------------------------------------------------
     REPLACE "<BR>"      WITH $CRLF      IN stHtml
     REPLACE "<P>"       WITH $CRLF      IN stHtml
     REPLACE "<B>"       WITH ""         IN stHtml
'+++
     REPLACE "<I>"       WITH ""         IN stHtml
'---
     REPLACE "</B>"      WITH ""         IN stHtml
     REPLACE "</FONT>"   WITH ""         IN stHtml
     REPLACE "</PRE>"    WITH $CRLF      IN stHtml
     REPLACE "<PRE>"     WITH $CRLF      IN stHtml
     REPLACE "<CENTER>"  WITH $CRLF      IN stHtml
     REPLACE "</CENTER>" WITH $CRLF      IN stHtml
     REPLACE CHR$(38,110,98,115,112,59)  WITH CHR$(32)   IN stHtml
     REPLACE CHR$(38,108,116,59)         WITH "<"        IN stHtml
     REPLACE CHR$(38,103,116,59)         WITH ">"        IN stHtml
'+++
' ,    
'     REPLACE "<HR>"      WITH $CRLF & STRING$(120,"_") & $CRLF IN stHtml
     REPLACE "<HR>"          WITH $CRLF    IN stHtml
'---
     REPLACE "</TABLE>"      WITH ""    IN stHtml
     REPLACE "<BLOCKQUOTE>"  WITH ""    IN stHtml
     REPLACE "</BLOCKQUOTE>" WITH ""    IN stHtml
     '--------------------------------------------------------------------------
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<IMG SRC=",">","")      = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<A HREF=", "</A>","" )  = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<TR ", ">","<TR>" )     = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<TD ", ">","<TD>")      = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<P ", "/P>","" )        = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<FONT ", ">","" )       = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<TABLE ", ">","" )      = -1
     DO:LOOP WHILE RemoveAndReplaceTags(stHtml,"<FORM ", "</FORM>","" ) = -1
     '--------------------------------------------------------------------------
     ' Add crlf code to each table tags
     '--------------------------------------------------------------------------
     REPLACE "<TD>"  WITH $CRLF & "<TD>"  & $CRLF IN stHtml
     REPLACE "<TR>"  WITH $CRLF & "<TR>"  & $CRLF IN stHtml
     REPLACE "</TD>" WITH $CRLF & "</TD>" & $CRLF IN stHtml
     REPLACE "</TR>" WITH $CRLF & "</TR>" & $CRLF IN stHtml
     FUNCTION = stHtml
END FUNCTION

FUNCTION fpGetTableInfo ALIAS "fpGetTableInfo" (BYVAL Info_Type AS LONG, BYVAL Table_Num AS LONG) EXPORT AS LONG
   IF Table_Num > UBOUND(HT) THEN Table_Num = UBOUND(HT)
   IF Table_Num < LBOUND(HT) THEN Table_Num = LBOUND(HT)
   SELECT CASE Info_Type
     CASE %T_Tables : FUNCTION = UBOUND(HT)
     CASE %T_Rows   : FUNCTION = HT(Table_Num).Rows
     CASE %T_Cols   : FUNCTION = HT(Table_Num).Cols
     CASE %T_Lines  : FUNCTION = HT(Table_Num).LLines
     CASE ELSE
       FUNCTION = 0
   END SELECT
END FUNCTION

'FUNCTION Between(s1 AS STRING,a1 AS STRING,a2 AS STRING,beg AS LONG) AS STRING
'     LOCAL c1 AS LONG,c2 AS LONG
'     c1 = INSTR( beg , s1 , a1 )
'     IF c1 THEN
'        c2 = INSTR( c1 + beg , s1 , a2 )
'        FUNCTION = MID$( s1 , c1 + LEN( a1 ) , c2 - c1 - LEN( a2 ) + 1 )
'     END IF
'END FUNCTION

' ,    
FUNCTION GetLink ALIAS "GetLink" () EXPORT AS STRING
    FUNCTION = gHTTP
END FUNCTION

'  .       
'    ,
'      
FUNCTION replace_Link( str AS STRING )AS STRING

    LOCAL p1 AS LONG
    LOCAL p2 AS LONG
    LOCAL p3 AS LONG
    LOCAL strtemp AS STRING
    LOCAL strtemp2 AS STRING
    LOCAL result AS STRING

    result = ""

    IF gHTTP = "" THEN
        p1 = INSTR( LCASE$(str) ,"&thread=http://")
        p2 = INSTR(p1, LCASE$(str), ".html&")
        IF p1 AND p2 THEN
            gHTTP = MID$(str, p1 + 8, p2 - p1 - 3)
        END IF
        p1 = 0
        p2 = 0
    END IF

    p1 = INSTR( LCASE$(str) ,"http://")
    strtemp = RIGHT$( str , LEN( str ) - p1+1)
    p2 = INSTR( strtemp  ,CHR$(34))
    p3 = INSTR( strtemp  ,CHR$(32))
    IF p2 AND p3 THEN
        p2 = MIN&(p2,p3)
    ELSE
        p2 = p2+p3
    END IF
    IF p1 AND p2 THEN
       result = LEFT$(strtemp , p2)
    END IF
    FUNCTION = result

END FUNCTION
